Data <- read.csv("C:/Users/ohuchi/Desktop/PTdata-saitamaover75.csv" , header=T)

hh <- nrow(Data)
b0 <- numeric(9)
fr <- function(x) {
  ##定数項Transportation
  b1 <- x[1]
  b2 <- x[2]
  b4 <- x[3]
  ##説明変数
  c1 <- x[4]
  c3 <- x[5]  
  a4 <- x[6]
  s3 <- x[7]
  a2 <- x[8]
  d3 <- x[9]

  
  ##対数尤度のための変数を宣言
  LL=0
  ##効用の計算
  train <-  exp ( c1*(Data$自動車保有数/100) + b1*matrix(1,nrow=hh, ncol=1))
  bicycle <-  exp ( a2*(Data$所要時間/10000) + b2*matrix(1,nrow=hh, ncol=1)) 
  car   <-  exp (d3*(Data$自動車保有O==1) + c3*(Data$自動車保有数/100) + s3*(Data$Sex==1))
  walk  <-  exp ( a4*(Data$所要時間/10000)+ b4*matrix(1,nrow=hh, ncol=1))
###選択確率の計算
##分母となる各々のexp(V)の和をつくる
deno <- (train + bicycle + car + walk)
PPtrain <- train/deno
PPbicycle <- bicycle/deno
PPcar <- car/deno
PPwalk <- walk/deno
##選択確率が0になってしまった場合に起こる問題の回避
Ptrain <- (PPtrain!=0) * PPtrain + (PPtrain ==0)
Pbicycle   <- (PPbicycle!=0) * PPbicycle + (PPbicycle ==0)
Pcar   <- (PPcar!=0) * PPcar + (PPcar ==0)
Pwalk <- (PPwalk!=0) * PPwalk + (PPwalk ==0)
##選択結果
Ctrain <- Data$Transportation == '1'
Cbicycle   <- Data$Transportation == '5'
Ccar   <- Data$Transportation == '3'
Cwalk  <- Data$Transportation == '6'
##対数尤度の計算
LL <- colSums((Data$EnlargeCoefficient) * Ctrain*log(Ptrain) + (Data$EnlargeCoefficient) * Ccar*log(Pcar) + (Data$EnlargeCoefficient) * Cbicycle*log(Pbicycle)+ (Data$EnlargeCoefficient) *Cwalk*log(Pwalk))
}
#####対数尤度関数frの最大化#####
##パラメータ値の最適化
res <- optim(b0,fr, method = "Nelder-Mead", hessian = TRUE, control=list(fnscale=-1))
##パラメータ推定値,ヘッセ行列
b <- res$par
hhh <- res$hessian  
##t値計算 
tval <- b/sqrt(-diag(solve(hhh)))
##初期尤度
L0 <- fr(b0)  
##最終尤度
LL <- res$value
#####結果の出力
print(res)
##初期尤度
print(L0)
##最終尤度
print(LL)
##
print((L0-LL)/L0)
##
print((L0-(LL-length(b)))/L0)
##パラメータ推定値
print(b)
## t値
print(tval)  



rm(list = ls())

